<?php
class Mdoq_Connector_Block_Adminhtml_System_Config_Form_Field_Authkey extends Mage_Adminhtml_Block_System_Config_Form_Field implements Varien_Data_Form_Element_Renderer_Interface
{
    protected function _construct()
    {
        parent::_construct();
        $this->setTemplate('mdoq/connector/system/config/form/field/authkey.phtml');
    }

    /**
     * Decorate field row html
     *
     * @param Varien_Data_Form_Element_Abstract $element
     * @param string $html
     * @return string
     */
    protected function _decorateRowHtml($element, $html)
    {
        return '<tr id="row_' . $element->getHtmlId() . '">' . $html . '</tr>'.$this->_toHtml();
    }

    /**
     * Generate synchronize button html
     * @return string
     */
    public function getRegenerateButton()
    {
        $button = $this->getLayout()->createBlock('adminhtml/widget_button')
            ->setData(array(
                'id'        => 'regenerate_button_authkey',
                'label'     => $this->helper('adminhtml')->__('Generate Auth Key'),
                'onclick'   => 'javascript:regenerateAuthKey(); return false;'
            ));

        return $button->toHtml();
    }

    /**
     * Generate synchronize button html
     * @return string
     */
    public function getCopyToClipboardButton()
    {
        $button = $this->getLayout()->createBlock('adminhtml/widget_button')
            ->setData(array(
                'id'        => 'copy_to_clipboard_button_authkey',
                'label'     => $this->helper('adminhtml')->__('Copy Auth Key to Clipboard'),
            ));

        return $button->toHtml();
    }

    public function getRegenerateUrl()
    {
        return Mage::getSingleton('adminhtml/url')->getUrl('*/connector_regenerate/authkey');
    }
}