<?php
class Mdoq_Connector_Helper_Data extends Mage_Core_Helper_Abstract
{
    const XML_PATH_ENABLED = 'mdoq_connector/settings/enabled';
    const XML_PATH_API_ENDPOINT = 'mdoq_connector/settings/api_endpoint';
    const XML_PATH_AUTH_KEY = 'mdoq_connector/settings/auth_key';
	const XML_PATH_VERSION = 'modules/Mdoq_Connector/version';
    const XML_PATH_PHP_BIN = 'mdoq_connector/advanced_settings/php_bin';

    const OLD_XML_PATH_ENDPOINT = 'zero1_gateway/settings/api_endpoint';
    const OLD_XML_PATH_ENABLED = 'zero1_gateway/settings/enabled';

    public function getApiEndpoint($store = null)
    {
        return Mage::getStoreConfig(self::XML_PATH_API_ENDPOINT, $store);
    }
    
    public function getAuthKey($store = null)
    {
        return Mage::getStoreConfig(self::XML_PATH_AUTH_KEY, $store);
    }

    public function isEnabled($store = null)
    {
        return (bool)Mage::getStoreConfig(self::XML_PATH_ENABLED, $store);
    }

    public function generateEndpoint()
    {
        $characters = 'abcdefghijklmopqrstuvwxyz0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $length = 255;
        $string = '';
        for($x = 0; $x < $length; $x++){
            $string .= substr($characters, rand(0, (strlen($characters) - 1)), 1);
        }
        return $string;
    }
    
    public function generateAuthKey()
    {
        $characters = 'abcdefghijklmopqrstuvwxyz0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $length = 32;
        $string = '';
        for($x = 0; $x < $length; $x++){
            $string .= substr($characters, rand(0, (strlen($characters) - 1)), 1);
        }
        return $string;
    }

	public function getVersion()
	{
		$config = Mage::getConfig();
		/** @var $value Mage_Core_Model_Config_Element */
		foreach($config->getNode(self::XML_PATH_VERSION) as $value){
			return $value->asArray();
		}
	}

    public function getPHPBin($store = null)
    {
        return Mage::getStoreConfig(self::XML_PATH_PHP_BIN, $store);
    }
    
    public function isEnvironmentMdoq()
    {
    	return (isset($_SERVER['HTTP_HOST']) && strpos($_SERVER['HTTP_HOST'], 'mdoq.io') !== false);
    }
}