<?php
class Mdoq_Connector_Model_Adminhtml_System_Config_Form_Field_Endpoint extends Mage_Core_Model_Config_Data
{
    protected function _beforeSave()
    {
        $value = $this->getValue();

        preg_match('#[^a-zA-Z0-9]#', $value, $matches);

        if(count($matches) > 0){
            Mage::throwException(
                Mage::helper('core')->__('Api endpoint may only contain [a-z0-9A-Z]')
            );
        }

        if(strlen($value) != 255){
            Mage::throwException(
                Mage::helper('core')->__('Api endpoint must be 255 characters')
            );
        }

        $this->setValue($value);
        return $this;
    }

    protected function _afterSave()
    {
        if ($this->isValueChanged()) {
            Mage::getConfig()->reinit();
            Mage::getModel('mdoq_connector/redirectManager')->update();
        }
    }
}