<?php
class Mdoq_Connector_Model_RedirectManager
{
    const IP_PATH = 'mdoq_connector';
    const TARGET_PATH = 'mdoq_connector';

    public function update()
    {
        foreach($this->getStoreIds() as $storeId){

            $collection = $this->getRewrite()->getResourceCollection();
            $collection->addFieldToFilter('target_path', array('eq' => self::IP_PATH));
            $collection->addFieldToFilter('store_id', array('eq' => $storeId));

            if($collection->count()){
                $rewrite = $collection->getFirstItem();
            }else{
                $rewrite = $this->getRewrite();
            }

            /** @var $rewrite Enterprise_UrlRewrite_Model_Redirect */
            $rewrite->setIdPath(self::IP_PATH);
            $rewrite->setTargetPath(self::TARGET_PATH);
            $rewrite->setStoreId($storeId);
            $rewrite->setRequestPath($this->getHelper()->getApiEndpoint());
            $rewrite->setIdentifier($this->getHelper()->getApiEndpoint());

            $rewrite->save();

            if($this->isEnterprise()){
                /** @var $client Enterprise_Mview_Model_Client */
                $client = Mage::getSingleton('core/factory')->getModel('enterprise_mview/client')->init('enterprise_url_rewrite_redirect');
                $client->execute('enterprise_urlrewrite/index_action_url_rewrite_redirect_refresh_row', array(
                    'redirect_id' => $rewrite->getId()
                ));
            }
        }
    }

    /**
     * @return Mdoq_Connector_Helper_Data
     */
    protected function getHelper()
    {
        return Mage::helper('mdoq_connector');
    }

    protected function getStoreIds()
    {
        $storeIds = array();
        /** @var Mage_Core_Model_Store $store */
        foreach(Mage::app()->getStores() as $store){
            $storeIds[] = $store->getId();
        }
        return $storeIds;
    }

    /**
     * @return false|Mage_Core_Model_Url_Rewrite
     */
    protected function getRewrite()
    {
        if(!$this->isEnterprise()){
            $rewrite = Mage::getModel('core/url_rewrite');
            if (!$rewrite) {
                $rewrite = Mage::getModel('core/factory')->getUrlRewriteInstance();
            }
        }else{
            $rewrite = Mage::getModel('enterprise_urlrewrite/redirect');
        }
        return $rewrite;
    }

    protected function isEnterprise()
    {
        if(Mage::getEdition() == Mage::EDITION_COMMUNITY || version_compare(Mage::getVersion(), '1.13.0.0', '<')){
            return false;
        }
        return true;
    }
}
