<?php
class Mdoq_Connector_IndexController extends Mage_Core_Controller_Front_Action
{
    public function indexAction()
    {
        if($this->getHelper()->getApiEndpoint() != ltrim($this->getRequest()->getOriginalPathInfo(), '/')){
            $this->_forward('noroute');
            return;
        }
        
        if(!$this->getHelper()->isEnabled()){
            $this->getResponse()->setBody('The MDOQ connector is disabled.');
            return;
        }
        
        if(!$this->getHelper()->getAuthKey() == null) {
    		$authHeader = Mage::app()->getRequest()->getHeader('x-mdoq-auth');
    		if($this->getHelper()->getAuthKey() != $authHeader) {
                $this->getResponse()->setBody('MDOQ Connector Error: authentication failed. Check the auth keys in your Magento Admin match the auth keys set against your live instance in MDOQ.');
                return;
    		}
        }

        $output = $this->getConnector()->run();

        $this->getResponse()->setBody($output);
        return;
    }

    /**
     * @return Mdoq_Connector_Helper_Data
     */
    protected function getHelper()
    {
        return Mage::helper('mdoq_connector');
    }

    /**
     * @return Mdoq_Connector_Model_Connector
     */
    protected function getConnector()
    {
        return Mage::getModel('mdoq_connector/connector');
    }
}