<?php
/* @var $installer Mage_Sales_Model_Resource_Setup */
$installer = $this;

/* @var $config Mage_Core_Model_Config */
$config = Mage::getConfig();

/* @var $helper Mdoq_Connector_Helper_Data */
$helper = Mage::helper('mdoq_connector');

/** @var Mdoq_Connector_Model_RedirectManager $redirectManager */
$redirectManager = Mage::getModel('mdoq_connector/redirectManager');


// move old data across if any is found
$oldData = $installer->getConnection()->fetchAssoc('select * from core_config_data where path in (
  \''.Mdoq_Connector_Helper_Data::OLD_XML_PATH_ENABLED.'\',
  \''.Mdoq_Connector_Helper_Data::OLD_XML_PATH_ENDPOINT.'\'
);');

if(empty($oldData)){
    // never had gateway installed
    $config->saveConfig($helper::XML_PATH_API_ENDPOINT, $helper->generateEndpoint(), 'default', 0);
}else{
    // gateway has previously been installed
    $installer->getConnection()->query('update core_config_data set path = \''.Mdoq_Connector_Helper_Data::XML_PATH_API_ENDPOINT.'\' where path = \''.Mdoq_Connector_Helper_Data::OLD_XML_PATH_ENDPOINT.'\';')->execute();
    $installer->getConnection()->query('update core_config_data set path = \''.Mdoq_Connector_Helper_Data::XML_PATH_ENABLED.'\' where path = \''.Mdoq_Connector_Helper_Data::OLD_XML_PATH_ENABLED.'\';')->execute();
}

$config->loadDb();

// clean up old rewrites
if(Mage::getEdition() == Mage::EDITION_COMMUNITY || version_compare(Mage::getVersion(), '1.13.0.0', '<')){

}else{
    $installer->getConnection()->query('delete from enterprise_url_rewrite  where target_path = \'zero1_gateway\';')->execute();
    $installer->getConnection()->query('delete from enterprise_url_rewrite_redirect  where target_path = \'zero1_gateway\';')->execute();
}
$installer->getConnection()->query('delete from core_url_rewrite where target_path = \'zero1_gateway\';')->execute();

$redirectManager->update();

